﻿internal class Program
{
    static unsafe void Main(string[] args)
    {
        {
            Console.WriteLine(BitConverter.IsLittleEndian);

            short x = 24592;
            IntPtr ptr = new IntPtr(&x);

            Console.WriteLine($"{ptr:x16}");
        }

        {
            char ch = '0';
            short x = 0x6010;
            short x2 = 0x1060;
            nuint addr = new nuint(&x);
            Console.WriteLine($"{addr:x16}");
            Console.WriteLine($"{((int)ch):x}");

            {
                byte[] buffer = BitConverter.GetBytes(x);
                File.WriteAllBytes("test_little.bin", buffer);
            }

            {
                byte upper = (byte)((x & 0xFF00) >> 8);
                byte lower = (byte)(x & 0xFF);
                byte[] buffer = new byte[] { lower, upper };
                File.WriteAllBytes("test_little.bin", buffer);
            }

            {
                byte upper = (byte)((x & 0xFF00) >> 8);
                byte lower = (byte)(x & 0xFF);
                byte[] buffer = new byte[] { upper, lower };
                File.WriteAllBytes("test_big.bin", buffer);
            }
        }
    }
}
